CodeForces 4D Mysterious Present(DP)

来源:互联网 发布:新ipad壁纸软件 编辑:程序博客网 时间:2024/05/22 02:28

题意:你有一张长宽为x,y的卡片同时有n个盒子,长宽分别为xi,yi。然后问你卡片最多塞多少层盒子并且把这些盒子按照从里到外输出。

思路:由于数据给小了,所以n^2的DP也是可以水过的~


#include<iostream>#include<cstdio>using namespace std;const int maxn = 5005;int x[maxn],y[maxn],dp[maxn];int p[maxn],n;int dfs(int a){if (dp[a])return dp[a];for (int i =1 ;i<=n;i++){if (x[a]<x[i] && y[a]<y[i])if (dfs(i)+1>dp[a]){p[a]=i;dp[a]=dfs(i)+1;}}return dp[a];}int main(){    scanf("%d",&n);for (int i = 0;i<=n;i++)scanf("%d%d",&x[i],&y[i]);int ans = dfs(0);printf("%d\n",ans);for (int i = p[0];i;i=p[i])printf("%d ",i);}

Description

Peter decided to wish happy birthday to his friend from Australia and send him a card. To make his present more mysterious, he decided to make a chain. Chain here is such a sequence of envelopes A = {a1,  a2,  ...,  an}, where the width and the height of the i-th envelope is strictly higher than the width and the height of the (i  -  1)-th envelope respectively. Chain size is the number of envelopes in the chain.

Peter wants to make the chain of the maximum size from the envelopes he has, the chain should be such, that he'll be able to put a card into it. The card fits into the chain if its width and height is lower than the width and the height of the smallest envelope in the chain respectively. It's forbidden to turn the card and the envelopes.

Peter has very many envelopes and very little time, this hard task is entrusted to you.

Input

The first line contains integers nwh (1  ≤ n ≤ 50001 ≤ w,  h  ≤ 106) — amount of envelopes Peter has, the card width and height respectively. Then there follow n lines, each of them contains two integer numbers wi and hi — width and height of the i-th envelope (1 ≤ wi,  hi ≤ 106).

Output

In the first line print the maximum chain size. In the second line print the numbers of the envelopes (separated by space), forming the required chain, starting with the number of the smallest envelope. Remember, please, that the card should fit into the smallest envelope. If the chain of maximum size is not unique, print any of the answers.

If the card does not fit into any of the envelopes, print number 0 in the single line.

Sample Input

Input
2 1 12 22 2
Output
11 
Input
3 3 35 412 119 8
Output
31 3 2 


0 0
原创粉丝点击